﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

public class DragScript : MonoBehaviour, IBeginDragHandler, IDragHandler, IEndDragHandler
{

    public GameObject timelinePrefab;
    GameObject timelineElement;
    GameObject timelineArea;
    TimelineScript timelineScript;
    int newSibIndex;

    public bool inBounds = false;

    public void OnBeginDrag(PointerEventData eventData)
    {
        timelineScript = FindObjectOfType<TimelineScript>();
        timelineArea = timelineScript.gameObject;
        timelineElement = Instantiate(timelinePrefab) as GameObject;
        GameObject canvas = FindObjectOfType<Canvas>().gameObject;
        timelineElement.transform.SetParent(canvas.transform);

        Debug.Log(timelineArea.GetComponent<RectTransform>().rect.xMin + (timelineArea.GetComponent<RectTransform>().rect.width / 2));
        Debug.Log(timelineArea.GetComponent<RectTransform>().rect.xMax + (timelineArea.GetComponent<RectTransform>().rect.width / 2));
        Debug.Log(timelineArea.GetComponent<RectTransform>().rect.yMin + (timelineArea.GetComponent<RectTransform>().rect.height / 2));
        Debug.Log(timelineArea.GetComponent<RectTransform>().rect.yMax + (timelineArea.GetComponent<RectTransform>().rect.height / 2));
    }

    public void OnDrag(PointerEventData eventData)
    {
        timelineElement.transform.position = eventData.position;

        newSibIndex = timelineScript.timeline.Count;

        for (int i = 0; i < timelineScript.timeline.Count; i++)
        {
            if (timelineElement.transform.position.x < timelineArea.transform.GetChild(i).position.x)
            {
                newSibIndex = i;
                if (timelineElement.transform.GetSiblingIndex() < newSibIndex)
                {
                    newSibIndex--;
                }
                break;
            }
        }
    }

    public void OnEndDrag(PointerEventData eventData)
    {


        if (eventData.position.x > (timelineArea.GetComponent<RectTransform>().rect.xMin + (timelineArea.GetComponent<RectTransform>().rect.width / 2)) && eventData.position.x < (timelineArea.GetComponent<RectTransform>().rect.xMax + (timelineArea.GetComponent<RectTransform>().rect.width / 2)))
        {

            Debug.Log("within x");
            if (eventData.position.y > (timelineArea.GetComponent<RectTransform>().rect.yMin + (timelineArea.GetComponent<RectTransform>().rect.height / 2)) && eventData.position.y < (timelineArea.GetComponent<RectTransform>().rect.yMax + (timelineArea.GetComponent<RectTransform>().rect.height / 2)))
                {
                Debug.Log("within y");
                timelineElement.transform.SetParent(timelineArea.GetComponentInChildren<ScrollRect>().gameObject.transform.GetChild(0));
                timelineElement.transform.SetSiblingIndex(newSibIndex);
            }
            else
            {
                Destroy(timelineElement);
            }
        }
        else
        {
            Destroy(timelineElement);
        }
    }
}
