﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class TimelineScript : MonoBehaviour
{
    public List<GameObject> timeline;
    public List<GameObject> corroborations;

    public GameObject corPanel;
    public GameObject submitButton;

    GameObject curSelected;

    public bool editActive;
    public Notebook notebook;
    public EvidenceHandler _handler;

    //checks if something has been added to the timeline for the tutorial
    public bool tutorialCheck;

    void Start()
    {
        // sets evidence handler
        _handler = FindObjectOfType<EvidenceHandler>();

        // sets all the timeline elements to the list
        foreach (Transform child in transform)
        {
            if (child.tag == "Timeline Element")
            {
                timeline.Add(child.gameObject);
            }

        }

        // edit is set to not active
        editActive = false;

        tutorialCheck = false;
    }

    void Update()
    {

    }

    // runs when edit button is pressed
    public void EditPressed()
    {
        // swaps whether its active or not
        editActive = !editActive;
        Debug.Log(editActive);

        if (editActive)
        {
            notebook.SelectedClear();
            // stops the player from corroborating
            notebook.canCorroborate = false;

            // clears corroboration list so multiples arent added
            corroborations.Clear();

            // resets corroboration list with all found corroborations
            foreach (Transform child in corPanel.transform)
            {
                corroborations.Add(child.gameObject);
            }

            // sets timeline elements to be interactable
            for (int i = 0; i < timeline.Count; i++)
            {
                timeline[i].GetComponent<Button>().interactable = true;
            }


        }
        else
        {
            // resets everything when edit is pressed again
            notebook.canCorroborate = true;

            for (int i = 0; i < timeline.Count; i++)
            {
                timeline[i].GetComponent<Button>().interactable = false;
            }
            if (curSelected != null)
            {
                curSelected.GetComponent<Image>().color = Color.white;
                curSelected = null;
            }
        }
    }

}